import uuid

def random_id():
	""" Generate a random id to be used for popups or other things that need to be uniquely identified. """
	return str(uuid.uuid4())

def color_popup(item_id, color="#FFFFFF"):
	"""Open a modal popup with a color picker.
	
	params:
		item_id: an identifier that will be included in the payload of the return message to allow filtering in the message handler
		color: an initial color in hex format (#FFFFFF)- may include alpha.
	"""
	popup_id = random_id()
	system.perspective.openPopup(
		id = popup_id,
		view = "ColorPopup",
		title = None,
		position = {'width': "290px", 'height': "290px"},
		showCloseIcon = False,
		draggable = False,
		resizable = False,
		modal = True,
		overlayDismiss = True,
		params = {
			'item_id': item_id,
			'popup_id': popup_id,
			'color': color
		}
	)
